#ifndef _KGR_PATCH_BSC1042892_H
#define _KGR_PATCH_BSC1042892_H

int kgr_patch_bsc1042892_init(void);
static void kgr_patch_bsc1042892_cleanup(void) {}

struct sock;
struct sk_buff;
struct flowi4;
struct ipcm_cookie;
struct rtable;
struct ipv6_txoptions;
struct flowi6;
struct rt6_info;
int kgr_ip_append_data(struct sock *sk, struct flowi4 *fl4,
		       int getfrag(void *from, char *to, int offset, int len,
				   int odd, struct sk_buff *skb),
		       void *from, int length, int transhdrlen,
		       struct ipcm_cookie *ipc, struct rtable **rtp,
		       unsigned int flags);
struct sk_buff *kgr_ip_make_skb(struct sock *sk,
				struct flowi4 *fl4,
				int getfrag(void *from, char *to, int offset,
					    int len, int odd, struct sk_buff *skb),
				void *from, int length, int transhdrlen,
				struct ipcm_cookie *ipc, struct rtable **rtp,
				unsigned int flags);
ssize_t kgr_ip_append_page(struct sock *sk, struct flowi4 *fl4, struct page *page,
			   int offset, size_t size, int flags);
int kgr_udp_send_skb(struct sk_buff *skb, struct flowi4 *fl4);
int kgr_ip6_append_data(struct sock *sk,
			int getfrag(void *from, char *to, int offset, int len,
				    int odd, struct sk_buff *skb),
			void *from, int length, int transhdrlen, int hlimit,
			int tclass, struct ipv6_txoptions *opt, struct flowi6 *fl6,
			struct rt6_info *rt, unsigned int flags, int dontfrag);

struct sk_buff *kgr_ip6_make_skb(struct sock *sk,
				 int getfrag(void *from, char *to, int offset,
					     int len, int odd, struct sk_buff *skb),
				 void *from, int length, int transhdrlen,
				 int hlimit, int tclass,
				 struct ipv6_txoptions *opt, struct flowi6 *fl6,
				 struct rt6_info *rt, unsigned int flags,
				 int dontfrag);

#define KGR_PATCH_BSC1042892_FUNCS				\
	KGR_PATCH(ip_append_data, kgr_ip_append_data),		\
	KGR_PATCH(ip_make_skb, kgr_ip_make_skb),		\
	KGR_PATCH(ip_append_page, kgr_ip_append_page),		\
	KGR_PATCH(udp_send_skb, kgr_udp_send_skb),		\
	KGR_PATCH(ip6_append_data, kgr_ip6_append_data),	\
	KGR_PATCH(ip6_make_skb, kgr_ip6_make_skb),

#endif
